<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' IssuesMaint CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' IssuesMaint CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "IssuesMaint.asp"
sTemplateFileName = "IssuesMaint.html"
'===============================


'===============================
' IssuesMaint PageSecurity begin
CheckSecurity(3)
' IssuesMaint PageSecurity end
'===============================

'===============================
' IssuesMaint Open Event begin
' IssuesMaint Open Event end
'===============================

'===============================
' IssuesMaint OpenAnyPage Event begin
' IssuesMaint OpenAnyPage Event end
'===============================

'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' IssuesMaint Show begin
'===============================
' Perform the form's action
'-------------------------------
' Initialize error variables
'-------------------------------
sIssueErr = ""

'-------------------------------
' Select the FormAction
'-------------------------------
Select Case sForm
  Case "Issue"
    IssueAction(sAction)
end select
'===============================

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
Issue_Show
Responses_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' IssuesMaint Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' IssuesMaint Close Event begin
' IssuesMaint Close Event end
'===============================
'===============================
' Action of the Record Form
'-------------------------------
Sub IssueAction(sAction)
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim bExecSQL: bExecSQL = true
  Dim sActionFileName : sActionFileName = ""
  Dim sWhere : sWhere = "" 
  Dim bErr : bErr = False
  Dim pPKissue_id : pPKissue_id = ""
  Dim fldissue_name : fldissue_name = ""
  Dim fldissue_desc : fldissue_desc = ""
  Dim flduser_id : flduser_id = ""
  Dim fldmodified_by : fldmodified_by = ""
  Dim flddate_submitted : flddate_submitted = ""
  Dim fldversion : fldversion = ""
  Dim fldtested : fldtested = ""
  Dim fldapproved : fldapproved = ""
  Dim fldassigned_to_orig : fldassigned_to_orig = ""
  Dim fldassigned_to : fldassigned_to = ""
  Dim fldpriority_id : fldpriority_id = ""
  Dim fldstatus_id : fldstatus_id = ""
'-------------------------------

'-------------------------------
' Issue Action begin
'-------------------------------
  sActionFileName = "IssuesList.asp"

'-------------------------------
' CANCEL action
'-------------------------------
  if sAction = "cancel" then

'-------------------------------
' Issue BeforeCancel Event begin
' Issue BeforeCancel Event end
'-------------------------------
    cn.Close
    Set cn = Nothing
    response.redirect sActionFileName
  end if
'-------------------------------

'-------------------------------
' Build WHERE statement
'-------------------------------
  if sAction = "update" or sAction = "delete" then
    pPKissue_id = GetParam("PK_issue_id")
    if IsEmpty(pPKissue_id) then exit sub
    sWhere = "issue_id=" & ToSQL(pPKissue_id, "Number")
  end if
'-------------------------------


'-------------------------------
' Load all form fields into variables
'-------------------------------
  fldissue_name = GetParam("issue_name")
  fldissue_desc = GetParam("issue_desc")
  flduser_id = GetParam("user_id")
  fldmodified_by = GetParam("modified_by")
  flddate_submitted = GetParam("date_submitted")
  fldversion = GetParam("version")
  fldtested = getCheckBoxValue(GetParam("tested"), "1", "0", "Number")
  fldapproved = getCheckBoxValue(GetParam("approved"), "1", "0", "Number")
  fldassigned_to_orig = GetParam("assigned_to_orig")
  fldassigned_to = GetParam("assigned_to")
  fldpriority_id = GetParam("priority_id")
  fldstatus_id = GetParam("status_id")

'-------------------------------
' Create SQL statement
'-------------------------------
  select case sAction
    case "update"
'-------------------------------
' Issue Update Event begin
' Issue Update Event end
'-------------------------------
      sSQL = "update issues set " & _
        "[issue_name]=" & ToSQL(fldissue_name, "Text") & _
        ",[issue_desc]=" & ToSQL(fldissue_desc, "Text") & _
        ",[user_id]=" & ToSQL(flduser_id, "Number") & _
        ",[modified_by]=" & ToSQL(fldmodified_by, "Number") & _
        ",[date_submitted]=" & ToSQL(flddate_submitted, "Date") & _
        ",[version]=" & ToSQL(fldversion, "Text") & _
        ",[tested]=" & fldtested & _
        ",[approved]=" & fldapproved & _
        ",[assigned_to_orig]=" & ToSQL(fldassigned_to_orig, "Number") & _
        ",[assigned_to]=" & ToSQL(fldassigned_to, "Number") & _
        ",[priority_id]=" & ToSQL(fldpriority_id, "Number") & _
        ",[status_id]=" & ToSQL(fldstatus_id, "Number")
      sSQL = sSQL & " where " & sWhere
    case "delete"
'-------------------------------
' Issue Delete Event begin
' Issue Delete Event end
'-------------------------------
      sSQL = "delete from issues where " & sWhere
  end select
'-------------------------------
'-------------------------------
' Issue BeforeExecute Event begin
' Issue BeforeExecute Event end
'-------------------------------

'-------------------------------
' Execute SQL statement
'-------------------------------
if len(sIssueErr) > 0 then Exit Sub
  on error resume next
  if bExecSQL then 
    cn.execute sSQL
  end if
  sIssueErr = ProcessError
  on error goto 0
  if len(sIssueErr) > 0 then Exit Sub
  cn.Close
  Set cn = Nothing
  response.redirect sActionFileName
'-------------------------------
' Issue Action end
'-------------------------------
end sub
'===============================

'===============================
' Display Record Form
'-------------------------------
Sub Issue_Show()
'-------------------------------
' Issue Show begin
'-------------------------------
  Dim sWhere : sWhere = ""
  Dim sFormTitle: sFormTitle = ""
  Dim bPK : bPK = True

'-------------------------------
' Load primary key and form parameters
'-------------------------------
  if sIssueErr = "" then
    pissue_id = GetParam("issue_id")
    SetVar "IssueError", ""
  else
    fldissue_id = GetParam("issue_id")
    fldissue_name = GetParam("issue_name")
    fldissue_desc = GetParam("issue_desc")
    flduser_id = GetParam("user_id")
    fldmodified_by = GetParam("modified_by")
    flddate_submitted = GetParam("date_submitted")
    fldversion = GetParam("version")
    fldtested = getCheckBoxValue(GetParam("tested"), "1", "0", "Number")
    fldapproved = getCheckBoxValue(GetParam("approved"), "1", "0", "Number")
    fldassigned_to_orig = GetParam("assigned_to_orig")
    fldassigned_to = GetParam("assigned_to")
    fldpriority_id = GetParam("priority_id")
    fldstatus_id = GetParam("status_id")
    pissue_id = GetParam("PK_issue_id")
    SetVar "sIssueErr", sIssueErr
    SetVar "FormTitle", sFormTitle
    Parse "IssueError", False
  end if
'-------------------------------

'-------------------------------
' Load all form fields

'-------------------------------

'-------------------------------
' Build WHERE statement

  if IsEmpty(pissue_id) then bPK = False
  
  sWhere = sWhere & "issue_id=" & ToSQL(pissue_id, "Number")
  SetVar "PK_issue_id", pissue_id
'-------------------------------
'-------------------------------
' Issue Open Event begin
' Issue Open Event end
'-------------------------------

  SetVar "FormTitle", sFormTitle

'-------------------------------
' Build SQL statement and open recordset
'-------------------------------
  sSQL = "select * from issues where " & sWhere
  openrs rs, sSQL
  bIsUpdateMode = (bPK and not(sAction = "insert" and sForm = "Issue") and not rs.eof)
'-------------------------------

'-------------------------------
' Load all fields into variables from recordset or input parameters
'-------------------------------
  if bIsUpdateMode then
    fldissue_id = GetValue(rs, "issue_id")

'-------------------------------
' Load data from recordset when form displayed first time
'-------------------------------
    if sIssueErr = "" then
      fldissue_name = GetValue(rs, "issue_name")
      fldissue_desc = GetValue(rs, "issue_desc")
      flduser_id = GetValue(rs, "user_id")
      fldmodified_by = GetValue(rs, "modified_by")
      flddate_submitted = GetValue(rs, "date_submitted")
      fldversion = GetValue(rs, "version")
      fldtested = GetValue(rs, "tested")
      fldapproved = GetValue(rs, "approved")
      fldassigned_to_orig = GetValue(rs, "assigned_to_orig")
      fldassigned_to = GetValue(rs, "assigned_to")
      fldpriority_id = GetValue(rs, "priority_id")
      fldstatus_id = GetValue(rs, "status_id")
    end if
    SetVar "IssueInsert", ""
    Parse "IssueEdit", False
'-------------------------------
' Issue ShowEdit Event begin
' Issue ShowEdit Event end
'-------------------------------
  else
    SetVar "IssueEdit", ""
    SetVar "IssueInsert", ""
'-------------------------------
' Issue ShowInsert Event begin
' Issue ShowInsert Event end
'-------------------------------
  end if
  Parse "IssueCancel", false
'-------------------------------
' Issue Show Event begin
' Issue Show Event end
'-------------------------------

'-------------------------------
' Show form field
'-------------------------------
      SetVar "issue_id", ToHTML(fldissue_id)
      SetVar "issue_name", ToHTML(fldissue_name)
      SetVar "issue_desc", ToHTML(fldissue_desc)
      SetVar "IssueLBuser_id", ""
      openrs rsuser_id, "select user_id, user_name from users order by 2"
      while not rsuser_id.EOF
        SetVar "ID", GetValue(rsuser_id, 0) : SetVar "Value", GetValue(rsuser_id, 1)
        if cstr(GetValue(rsuser_id, 0)) = cstr(flduser_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssueLBuser_id", True
        rsuser_id.MoveNext
      wend
      set rsuser_id = nothing
    
      SetVar "IssueLBmodified_by", ""
      openrs rsmodified_by, "select user_id, user_name from users order by 2"
      while not rsmodified_by.EOF
        SetVar "ID", GetValue(rsmodified_by, 0) : SetVar "Value", GetValue(rsmodified_by, 1)
        if cstr(GetValue(rsmodified_by, 0)) = cstr(fldmodified_by) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssueLBmodified_by", True
        rsmodified_by.MoveNext
      wend
      set rsmodified_by = nothing
    
      SetVar "date_submitted", ToHTML(flddate_submitted)
      SetVar "version", ToHTML(fldversion)
  if (LCase(fldtested) = LCase("1")) then
    SetVar "tested_CHECKED", "CHECKED"
  else
    SetVar "tested_CHECKED", ""
  end if

  if (LCase(fldapproved) = LCase("1")) then
    SetVar "approved_CHECKED", "CHECKED"
  else
    SetVar "approved_CHECKED", ""
  end if

      SetVar "IssueLBassigned_to_orig", ""
      openrs rsassigned_to_orig, "select user_id, user_name from users order by 2"
      while not rsassigned_to_orig.EOF
        SetVar "ID", GetValue(rsassigned_to_orig, 0) : SetVar "Value", GetValue(rsassigned_to_orig, 1)
        if cstr(GetValue(rsassigned_to_orig, 0)) = cstr(fldassigned_to_orig) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssueLBassigned_to_orig", True
        rsassigned_to_orig.MoveNext
      wend
      set rsassigned_to_orig = nothing
    
      SetVar "IssueLBassigned_to", ""
      openrs rsassigned_to, "select user_id, user_name from users order by 2"
      while not rsassigned_to.EOF
        SetVar "ID", GetValue(rsassigned_to, 0) : SetVar "Value", GetValue(rsassigned_to, 1)
        if cstr(GetValue(rsassigned_to, 0)) = cstr(fldassigned_to) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssueLBassigned_to", True
        rsassigned_to.MoveNext
      wend
      set rsassigned_to = nothing
    
      SetVar "IssueLBpriority_id", ""
      openrs rspriority_id, "select priority_id, priority_desc from priorities order by 2"
      while not rspriority_id.EOF
        SetVar "ID", GetValue(rspriority_id, 0) : SetVar "Value", GetValue(rspriority_id, 1)
        if cstr(GetValue(rspriority_id, 0)) = cstr(fldpriority_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssueLBpriority_id", True
        rspriority_id.MoveNext
      wend
      set rspriority_id = nothing
    
      SetVar "IssueLBstatus_id", ""
      openrs rsstatus_id, "select status_id, status from statuses order by 2"
      while not rsstatus_id.EOF
        SetVar "ID", GetValue(rsstatus_id, 0) : SetVar "Value", GetValue(rsstatus_id, 1)
        if cstr(GetValue(rsstatus_id, 0)) = cstr(fldstatus_id) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
        Parse "IssueLBstatus_id", True
        rsstatus_id.MoveNext
      wend
      set rsstatus_id = nothing
    
  Parse "FormIssue", False

'-------------------------------
' Issue Close Event begin
' Issue Close Event end
'-------------------------------

Set rs = Nothing

'-------------------------------
' Issue Show end
'-------------------------------
End Sub
'===============================

'===============================
' Display Grid Form
'-------------------------------
Sub Responses_Show()
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim rs
  Dim sWhere : sWhere = ""
  Dim sOrder : sOrder = ""
  Dim sSQL : sSQL = ""
  Dim sFormTitle: sFormTitle = "Response History"
  Dim HasParam : HasParam = false
  Dim bReq : bReq = true

  SetVar "TransitParams", "issue_id=" & ToURL(GetParam("issue_id")) & "&"
  SetVar "FormParams", "issue_id=" & ToURL(GetParam("issue_id")) & "&"

'-------------------------------
' Build WHERE statement
'-------------------------------
  pissue_id = GetParam("issue_id")
  if IsNumeric(pissue_id) and not isEmpty(pissue_id) then pissue_id = ToSQL(pissue_id, "Number") else pissue_id = Empty
  if not isEmpty(pissue_id) then
    HasParam = true
    sWhere = sWhere & "r.[issue_id]=" & pissue_id
  else
    bReq = false
  end if


  if HasParam then
    sWhere = " AND (" & sWhere & ")"
  end if
  
'-------------------------------
' Build ORDER BY statement
'-------------------------------
  sOrder = " order by r.date_response Asc"

'-------------------------------
' Build base SQL statement
'-------------------------------
  sSQL = "select [r].[assigned_to] as r_assigned_to, " & _
    "[r].[date_response] as r_date_response, " & _
    "[r].[issue_id] as r_issue_id, " & _
    "[r].[priority_id] as r_priority_id, " & _
    "[r].[response] as r_response, " & _
    "[r].[response_id] as r_response_id, " & _
    "[r].[status_id] as r_status_id, " & _
    "[r].[user_id] as r_user_id, " & _
    "[u].[user_id] as u_user_id, " & _
    "[u].[user_name] as u_user_name, " & _
    "[u1].[user_id] as u1_user_id, " & _
    "[u1].[user_name] as u1_user_name, " & _
    "[p].[priority_id] as p_priority_id, " & _
    "[p].[priority_desc] as p_priority_desc, " & _
    "[s].[status_id] as s_status_id, " & _
    "[s].[status] as s_status " & _
    " from [responses] r, [users] u, [users] u1, [priorities] p, [statuses] s" & _
    " where [u].[user_id]=r.[user_id] and [u1].[user_id]=r.[assigned_to] and [p].[priority_id]=r.[priority_id] and [s].[status_id]=r.[status_id]  "
'-------------------------------

'-------------------------------
' Responses Open Event begin
' Responses Open Event end
'-------------------------------

'-------------------------------
' Assemble full SQL statement
'-------------------------------
  sSQL = sSQL & sWhere & sOrder
'-------------------------------

SetVar "FormTitle", sFormTitle

'-------------------------------
' Process if form has all required parameter
'-------------------------------
  if not bReq then
    SetVar "DListResponses", ""
    Parse "ResponsesNoRecords", False
    Parse "FormResponses", False
    exit sub
  end if
'-------------------------------

'-------------------------------
' Open the recordset
'-------------------------------
  openrs rs, sSQL
'-------------------------------

'-------------------------------
' Process empty recordset
'-------------------------------
  if rs.eof then
    set rs = nothing
    SetVar "DListResponses", ""
    Parse "ResponsesNoRecords", False
    Parse "FormResponses", False
    exit sub
  end if
'-------------------------------


'-------------------------------
' Display grid based on recordset
'-------------------------------
  while not rs.EOF 
'-------------------------------
' Create field variables based on database fields
'-------------------------------
    fldField1_URLLink = "ResponseMaint.asp"
    fldField1_response_id = GetValue(rs, "r_response_id")
    fldassigned_to = GetValue(rs, "u1_user_name")
    flddate_response = GetValue(rs, "r_date_response")
    fldpriority_id = GetValue(rs, "p_priority_desc")
    fldresponse = GetValue(rs, "r_response")
    fldresponse_id = GetValue(rs, "r_response_id")
    fldstatus_id = GetValue(rs, "s_status")
    flduser_id = GetValue(rs, "u_user_name")
    fldField1= "Edit"
'-------------------------------
' Responses Show begin
'-------------------------------

'-------------------------------
' Responses Show Event begin
' Responses Show Event end
'-------------------------------

'-------------------------------
' Replace Template fields with database values
'-------------------------------
    
      SetVar "response_id", ToHTML(fldresponse_id)
      SetVar "user_id", ToHTML(flduser_id)
      SetVar "date_response", ToHTML(flddate_response)
      SetVar "response", ToHTML(fldresponse)
      SetVar "assigned_to", ToHTML(fldassigned_to)
      SetVar "priority_id", ToHTML(fldpriority_id)
      SetVar "status_id", ToHTML(fldstatus_id)
      SetVar "Field1", ToHTML(fldField1)
      SetVar "Field1_URLLink", fldField1_URLLink
      SetVar "PrmField1_response_id", ToURL(fldField1_response_id)
'-------------------------------
' Process the record separator
'-------------------------------
    if rs.EOF  then
       SetVar "ResponsesRecordSeparator", ""
    else
      Parse "ResponsesRecordSeparator", false
    end if
'-------------------------------
    Parse "DListResponses", True

'-------------------------------
' Responses Show end
'-------------------------------

'-------------------------------
' Move to the next record 
'-------------------------------
    rs.MoveNext
  wend
'-------------------------------


'-------------------------------
' Finish form processing
'-------------------------------
  set rs = nothing
  SetVar "ResponsesNoRecords", ""
  Parse "FormResponses", False

'-------------------------------
' Responses Close Event begin
' Responses Close Event end
'-------------------------------
End Sub
'===============================

%>