<%
'(C) Copyright 2001 by UltraApps
'View files/license.html for Legal Information
'-------------------------------
' UserMaint CustomIncludes begin
%>

<!-- #INCLUDE FILE="Common.asp" -->
<!-- #INCLUDE FILE="Header.asp" -->
<!-- #INCLUDE FILE="Footer.asp" -->

<%
' UserMaint CustomIncludes end
'-------------------------------

'===============================
' Save Page and File Name available into variables
'-------------------------------
sFileName = "UserMaint.asp"
sTemplateFileName = "UserMaint.html"
'===============================


'===============================
' UserMaint PageSecurity begin
CheckSecurity(3)
' UserMaint PageSecurity end
'===============================

'===============================
' UserMaint Open Event begin
' UserMaint Open Event end
'===============================

'===============================
' UserMaint OpenAnyPage Event begin
' UserMaint OpenAnyPage Event end
'===============================

'===============================
'Save the name of the form and type of action into the variables
'-------------------------------
sAction = GetParam("FormAction")
sForm = GetParam("FormName")
'===============================

' UserMaint Show begin
'===============================
' Perform the form's action
'-------------------------------
' Initialize error variables
'-------------------------------
sUserErr = ""

'-------------------------------
' Select the FormAction
'-------------------------------
Select Case sForm
  Case "User"
    UserAction(sAction)
end select
'===============================

'===============================
' Display page
'-------------------------------
' Load HTML template for this page
'-------------------------------
LoadTemplate sAppPath & sTemplateFileName, "main"
'-------------------------------
' Load HTML template of Header and Footer
'-------------------------------
LoadTemplate sHeaderFileName, "Header"
LoadTemplate sFooterFileName, "Footer"
'-------------------------------
SetVar "FileName", sFileName


'-------------------------------
' Step through each form
'-------------------------------
Menu_Show
FooterForm_Show
User_Show
'-------------------------------
' Process page templates
'-------------------------------
Parse "Header", False
Parse "Footer", False
Parse "main", False
'-------------------------------
' Output the page to the browser
'-------------------------------
Response.write PrintVar("main")

' UserMaint Show end

'-------------------------------
' Destroy all object variables
'-------------------------------
cn.Close
Set cn = Nothing
UnloadTemplate
'===============================

'===============================
' UserMaint Close Event begin
' UserMaint Close Event end
'===============================
'===============================
' Action of the Record Form
'-------------------------------
Sub UserAction(sAction)
'-------------------------------
' Initialize variables  
'-------------------------------
  Dim bExecSQL: bExecSQL = true
  Dim sActionFileName : sActionFileName = ""
  Dim sWhere : sWhere = "" 
  Dim bErr : bErr = False
  Dim pPKuser_id : pPKuser_id = ""
  Dim fldlogin : fldlogin = ""
  Dim fldpass : fldpass = ""
  Dim fldsecurity_level : fldsecurity_level = ""
  Dim flduser_name : flduser_name = ""
  Dim fldemail : fldemail = ""
'-------------------------------

'-------------------------------
' User Action begin
'-------------------------------
  sActionFileName = "UserList.asp"

'-------------------------------
' Build WHERE statement
'-------------------------------
  if sAction = "update" or sAction = "delete" then
    pPKuser_id = GetParam("PK_user_id")
    if IsEmpty(pPKuser_id) then exit sub
    sWhere = "user_id=" & ToSQL(pPKuser_id, "Number")
  end if
'-------------------------------


'-------------------------------
' Load all form fields into variables
'-------------------------------
  fldlogin = GetParam("login")
  fldpass = GetParam("pass")
  fldsecurity_level = GetParam("security_level")
  flduser_name = GetParam("user_name")
  fldemail = GetParam("email")

'-------------------------------
' Validate fields
'-------------------------------
  if sAction = "insert" or sAction = "update" then
    if IsEmpty(fldlogin) then
      sUserErr = sUserErr & "The value in field Login is required.<br>"
    end if
    if IsEmpty(fldpass) then
      sUserErr = sUserErr & "The value in field Password is required.<br>"
    end if
    if IsEmpty(fldsecurity_level) then
      sUserErr = sUserErr & "The value in field Security Level is required.<br>"
    end if
    if IsEmpty(flduser_name) then
      sUserErr = sUserErr & "The value in field Name is required.<br>"
    end if
    if not isNumeric(fldsecurity_level) then
      sUserErr = sUserErr & "The value in field Security Level is incorrect.<br>"
    end if
'-------------------------------
' User Check Event begin
' User Check Event end
'-------------------------------
    If len(sUserErr) > 0 then
      exit sub
    end if
  end if
'-------------------------------


'-------------------------------
' Create SQL statement
'-------------------------------
  select case sAction
    case "insert"
'-------------------------------
' User Insert Event begin
' User Insert Event end
'-------------------------------
      sSQL = "insert into users (" & _
          "[login]," & _
          "[pass]," & _
          "[security_level]," & _
          "[user_name]," & _
          "[email])" & _
          " values (" & _
          ToSQL(fldlogin, "Text") & "," & _
          ToSQL(fldpass, "Text") & "," & _
          ToSQL(fldsecurity_level, "Number") & "," & _
          ToSQL(flduser_name, "Text") & "," & _
          ToSQL(fldemail, "Text") & _
          ")"
    case "update"
'-------------------------------
' User Update Event begin
' User Update Event end
'-------------------------------
      sSQL = "update users set " & _
        "[login]=" & ToSQL(fldlogin, "Text") & _
        ",[pass]=" & ToSQL(fldpass, "Text") & _
        ",[security_level]=" & ToSQL(fldsecurity_level, "Number") & _
        ",[user_name]=" & ToSQL(flduser_name, "Text") & _
        ",[email]=" & ToSQL(fldemail, "Text")
      sSQL = sSQL & " where " & sWhere
    case "delete"
'-------------------------------
' User Delete Event begin
' User Delete Event end
'-------------------------------
      sSQL = "delete from users where " & sWhere
  end select
'-------------------------------
'-------------------------------
' User BeforeExecute Event begin
' User BeforeExecute Event end
'-------------------------------

'-------------------------------
' Execute SQL statement
'-------------------------------
if len(sUserErr) > 0 then Exit Sub
  on error resume next
  if bExecSQL then 
    cn.execute sSQL
  end if
  sUserErr = ProcessError
  on error goto 0
  if len(sUserErr) > 0 then Exit Sub
  cn.Close
  Set cn = Nothing
  response.redirect sActionFileName
'-------------------------------
' User Action end
'-------------------------------
end sub
'===============================

'===============================
' Display Record Form
'-------------------------------
Sub User_Show()
'-------------------------------
' User Show begin
'-------------------------------
  Dim sWhere : sWhere = ""
  Dim sFormTitle: sFormTitle = "Add/Edit User"
  Dim bPK : bPK = True

'-------------------------------
' Load primary key and form parameters
'-------------------------------
  if sUserErr = "" then
    puser_id = GetParam("user_id")
    SetVar "UserError", ""
  else
    flduser_id = GetParam("user_id")
    fldlogin = GetParam("login")
    fldpass = GetParam("pass")
    fldsecurity_level = GetParam("security_level")
    flduser_name = GetParam("user_name")
    fldemail = GetParam("email")
    puser_id = GetParam("PK_user_id")
    SetVar "sUserErr", sUserErr
    SetVar "FormTitle", sFormTitle
    Parse "UserError", False
  end if
'-------------------------------

'-------------------------------
' Load all form fields

'-------------------------------

'-------------------------------
' Build WHERE statement

  if IsEmpty(puser_id) then bPK = False
  
  sWhere = sWhere & "user_id=" & ToSQL(puser_id, "Number")
  SetVar "PK_user_id", puser_id
'-------------------------------
'-------------------------------
' User Open Event begin
' User Open Event end
'-------------------------------

  SetVar "FormTitle", sFormTitle

'-------------------------------
' Build SQL statement and open recordset
'-------------------------------
  sSQL = "select * from users where " & sWhere
  openrs rs, sSQL
  bIsUpdateMode = (bPK and not(sAction = "insert" and sForm = "User") and not rs.eof)
'-------------------------------

'-------------------------------
' Load all fields into variables from recordset or input parameters
'-------------------------------
  if bIsUpdateMode then
    flduser_id = GetValue(rs, "user_id")

'-------------------------------
' Load data from recordset when form displayed first time
'-------------------------------
    if sUserErr = "" then
      fldlogin = GetValue(rs, "login")
      fldpass = GetValue(rs, "pass")
      fldsecurity_level = GetValue(rs, "security_level")
      flduser_name = GetValue(rs, "user_name")
      fldemail = GetValue(rs, "email")
    end if
    SetVar "UserInsert", ""
    Parse "UserEdit", False
'-------------------------------
' User ShowEdit Event begin
' User ShowEdit Event end
'-------------------------------
  else
    SetVar "UserEdit", ""
    Parse "UserInsert", False
'-------------------------------
' User ShowInsert Event begin
' User ShowInsert Event end
'-------------------------------
  end if
  SetVar "UserCancel", ""
'-------------------------------
' User Show Event begin
' User Show Event end
'-------------------------------

'-------------------------------
' Show form field
'-------------------------------
      SetVar "user_id", ToHTML(flduser_id)
      SetVar "login", ToHTML(fldlogin)
      SetVar "pass", ToHTML(fldpass)
      SetVar "UserLBsecurity_level", ""
      LOV = Split("1;Customer;2;Developer;3;Administrator", ";")
      if (ubound(LOV) mod 2) = 1 then
        for i = 0 to ubound(LOV) step 2
          SetVar "ID", LOV(i) : SetVar "Value", LOV(i+1)
          if cstr(LOV(i)) = cstr(fldsecurity_level) then SetVar "Selected", "SELECTED" else SetVar "Selected", ""
          Parse "UserLBsecurity_level", True
        next
      end if
    
      SetVar "user_name", ToHTML(flduser_name)
      SetVar "email", ToHTML(fldemail)
  Parse "FormUser", False

'-------------------------------
' User Close Event begin
' User Close Event end
'-------------------------------

Set rs = Nothing

'-------------------------------
' User Show end
'-------------------------------
End Sub
'===============================
%>